#ifndef IOB_H_
#define IOB_H_

#include "config.h"

#ifdef USE_IOB

#define IDX_VERSION  0
#define IDX_SETUP    1
#define IDX_CURRENT  2
#define IDX_POWER    3
#define IDX_KWH      4
#define IDX_WM       5
#define IDX_VOLTAGE  6
#define IDX_TEMP     7

#define SRC_RIOB    1
#define SRC_IOB     2
#define SRC_BTN     3

typedef void (*IHProc)( struct _IobVar *var, int idx );

typedef  struct _IobVar
{
   char     *pvname;
   uint8_t  type;
   char     *unit;
   uint32_t state;
   IHProc   handler;
   uint8_t  access_mode;   /* 1=need_access, 3=access_ok */
   uint32_t srvid;
   union {
    struct {
      int32_t  val;
      int32_t  rangeb;
      int32_t  rangee;
    } i;
    struct {
      double   val;
      double   rangeb;
      double   rangee;
    } f;
    struct {
      char    *val;
    } s;
   } u;
   struct _Evr  *evr;
} IobVar;

#else

#define _iobSetVar(a,b,c)
#define prepareIobSetup()
#define iobSetHandler(a,b)
#define runIobLoop()

#endif

#endif
